diff --git a/registry/.gitignore b/registry/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/registry/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/registry/.mvn/wrapper/maven-wrapper.jar b/registry/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..c1dd12f
Binary files /dev/null and b/registry/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/registry/.mvn/wrapper/maven-wrapper.properties b/registry/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..b74bf7f
--- /dev/null
+++ b/registry/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.8.6/apache-maven-3.8.6-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar
diff --git a/registry/build-native.sh b/registry/build-native.sh
new file mode 100755
index 0000000..43ed830
--- /dev/null
+++ b/registry/build-native.sh
@@ -0,0 +1,5 @@
+#!/usr/bin/env bash
+
+# Put your GRAALVM location here.
+export GRAALVM_HOME=/home/andrew/Downloads/graalvm-ce-java17-22.2.0
+mvn -Pnative -DskipTests clean package
diff --git a/registry/mvnw b/registry/mvnw
new file mode 100755
index 0000000..8a8fb22
--- /dev/null
+++ b/registry/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/registry/mvnw.cmd b/registry/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/registry/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/registry/pom.xml b/registry/pom.xml
new file mode 100644
index 0000000..e99425c
--- /dev/null
+++ b/registry/pom.xml
@@ -0,0 +1,150 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.7.2
+
+
+ nl.andrewl
+ aos2-registry-api
+ 0.0.1-SNAPSHOT
+ aos2-registry-api
+ Registry API for Ace of Shades 2 servers.
+
+ 17
+
+ 0.12.1
+
+
+
+ org.springframework.boot
+ spring-boot-starter-webflux
+
+
+ org.springframework.experimental
+ spring-native
+ ${spring-native.version}
+
+
+
+ org.springframework.boot
+ spring-boot-devtools
+ runtime
+ true
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ io.projectreactor
+ reactor-test
+ test
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+ ${repackage.classifier}
+
+ paketobuildpacks/builder:tiny
+
+ true
+
+
+
+
+
+ org.springframework.experimental
+ spring-aot-maven-plugin
+ ${spring-native.version}
+
+
+ test-generate
+
+ test-generate
+
+
+
+ generate
+
+ generate
+
+
+
+
+
+
+
+
+ spring-releases
+ Spring Releases
+ https://repo.spring.io/release
+
+ false
+
+
+
+
+
+ spring-releases
+ Spring Releases
+ https://repo.spring.io/release
+
+ false
+
+
+
+
+
+
+ native
+
+ exec
+ 0.9.13
+
+
+
+ org.junit.platform
+ junit-platform-launcher
+ test
+
+
+
+
+
+ org.graalvm.buildtools
+ native-maven-plugin
+ ${native-buildtools.version}
+ true
+
+
+ test-native
+ test
+
+ test
+
+
+
+ build-native
+ package
+
+ build
+
+
+
+
+
+
+
+
+
+
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/Aos2RegistryApiApplication.java b/registry/src/main/java/nl/andrewl/aos2registryapi/Aos2RegistryApiApplication.java
new file mode 100644
index 0000000..bf24246
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/Aos2RegistryApiApplication.java
@@ -0,0 +1,15 @@
+package nl.andrewl.aos2registryapi;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.scheduling.annotation.EnableScheduling;
+
+@SpringBootApplication
+@EnableScheduling
+public class Aos2RegistryApiApplication {
+
+ public static void main(String[] args) {
+ SpringApplication.run(Aos2RegistryApiApplication.class, args);
+ }
+
+}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/ServerInfoValidator.java b/registry/src/main/java/nl/andrewl/aos2registryapi/ServerInfoValidator.java
new file mode 100644
index 0000000..5c9404f
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/ServerInfoValidator.java
@@ -0,0 +1,33 @@
+package nl.andrewl.aos2registryapi;
+
+import nl.andrewl.aos2registryapi.dto.ServerInfoPayload;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Optional;
+
+public class ServerInfoValidator {
+
+ public boolean validateName(String name) {
+ return name != null && !name.isBlank() && name.length() <= 64;
+ }
+
+ public boolean validateDescription(String description) {
+ return description == null ||
+ (!description.isBlank() && description.length() <= 256);
+ }
+
+ public boolean validatePlayerCounts(int max, int current) {
+ return max > 0 && current >= 0 && current <= max && max < 1000;
+ }
+
+ public Optional> validatePayload(ServerInfoPayload payload) {
+ List messages = new ArrayList<>(3);
+ if (payload.port() < 0 || payload.port() > 65535) messages.add("Invalid port.");
+ if (!validateName(payload.name())) messages.add("Invalid name.");
+ if (!validateDescription(payload.description())) messages.add("Invalid description.");
+ if (!validatePlayerCounts(payload.maxPlayers(), payload.currentPlayers())) messages.add("Invalid player counts.");
+ if (messages.size() > 0) return Optional.of(messages);
+ return Optional.empty();
+ }
+}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/ServerRegistry.java b/registry/src/main/java/nl/andrewl/aos2registryapi/ServerRegistry.java
new file mode 100644
index 0000000..21176c4
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/ServerRegistry.java
@@ -0,0 +1,90 @@
+package nl.andrewl.aos2registryapi;
+
+import nl.andrewl.aos2registryapi.dto.ServerInfoPayload;
+import nl.andrewl.aos2registryapi.dto.ServerInfoResponse;
+import nl.andrewl.aos2registryapi.model.ServerIdentifier;
+import nl.andrewl.aos2registryapi.model.ServerInfo;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.springframework.http.HttpStatus;
+import org.springframework.scheduling.annotation.Scheduled;
+import org.springframework.stereotype.Component;
+import org.springframework.web.server.ResponseStatusException;
+import reactor.core.publisher.Flux;
+
+import java.time.Duration;
+import java.time.Instant;
+import java.util.Comparator;
+import java.util.LinkedList;
+import java.util.Map;
+import java.util.Queue;
+import java.util.concurrent.ConcurrentHashMap;
+import java.util.concurrent.TimeUnit;
+import java.util.stream.Stream;
+
+@Component
+public class ServerRegistry {
+ private static final Logger log = LoggerFactory.getLogger(ServerRegistry.class);
+
+ public static final Duration SERVER_TIMEOUT = Duration.ofMinutes(5);
+ public static final Duration SERVER_MIN_UPDATE = Duration.ofMinutes(1);
+
+ private final Map servers = new ConcurrentHashMap<>();
+ private final ServerInfoValidator infoValidator = new ServerInfoValidator();
+
+ public Flux getServers() {
+ Stream stream = servers.entrySet().stream()
+ .sorted(Comparator.comparing(entry -> entry.getValue().getLastUpdatedAt()))
+ .map(entry -> new ServerInfoResponse(
+ entry.getKey().host(),
+ entry.getKey().port(),
+ entry.getValue().getName(),
+ entry.getValue().getDescription(),
+ entry.getValue().getMaxPlayers(),
+ entry.getValue().getCurrentPlayers(),
+ entry.getValue().getLastUpdatedAt().toEpochMilli()
+ ));
+ return Flux.fromStream(stream);
+ }
+
+ public void acceptInfo(ServerIdentifier ident, ServerInfoPayload payload) {
+ var result = infoValidator.validatePayload(payload);
+ if (result.isPresent()) {
+ throw new ResponseStatusException(HttpStatus.BAD_REQUEST, String.join(" ", result.get()));
+ }
+ ServerInfo info = servers.get(ident);
+ if (info != null) {
+ Instant now = Instant.now();
+ // Check if this update was sent too fast.
+ if (Duration.between(info.getLastUpdatedAt(), now).compareTo(SERVER_MIN_UPDATE) < 0) {
+ throw new ResponseStatusException(HttpStatus.TOO_MANY_REQUESTS, "Server update rate limit exceeded.");
+ }
+ // Update existing server.
+ info.setName(payload.name());
+ info.setDescription(payload.description());
+ info.setMaxPlayers(payload.maxPlayers());
+ info.setCurrentPlayers(payload.currentPlayers());
+ info.setLastUpdatedAt(now);
+ } else {
+ // Save new server.
+ servers.put(ident, new ServerInfo(payload.name(), payload.description(), payload.maxPlayers(), payload.currentPlayers()));
+ }
+ }
+
+ @Scheduled(fixedRate = 1, timeUnit = TimeUnit.MINUTES, initialDelay = 1)
+ public void purgeOldServers() {
+ log.info("Purging old servers.");
+ Queue removalQueue = new LinkedList<>();
+ final Instant cutoff = Instant.now().minus(SERVER_TIMEOUT);
+ for (var entry : servers.entrySet()) {
+ var ident = entry.getKey();
+ var server = entry.getValue();
+ if (server.getLastUpdatedAt().isBefore(cutoff)) {
+ removalQueue.add(ident);
+ }
+ }
+ while (!removalQueue.isEmpty()) {
+ servers.remove(removalQueue.remove());
+ }
+ }
+}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/api/ErrorAdvice.java b/registry/src/main/java/nl/andrewl/aos2registryapi/api/ErrorAdvice.java
new file mode 100644
index 0000000..a3abc4d
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/api/ErrorAdvice.java
@@ -0,0 +1,21 @@
+package nl.andrewl.aos2registryapi.api;
+
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.ExceptionHandler;
+import org.springframework.web.bind.annotation.RestControllerAdvice;
+import org.springframework.web.server.ResponseStatusException;
+
+import java.util.HashMap;
+import java.util.Map;
+
+@RestControllerAdvice
+public class ErrorAdvice {
+
+ @ExceptionHandler(ResponseStatusException.class)
+ public ResponseEntity> handleRSE(ResponseStatusException e) {
+ Map data = new HashMap<>();
+ data.put("code", e.getRawStatusCode());
+ data.put("message", e.getReason());
+ return ResponseEntity.status(e.getStatus()).body(data);
+ }
+}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/api/ServersController.java b/registry/src/main/java/nl/andrewl/aos2registryapi/api/ServersController.java
new file mode 100644
index 0000000..78a0e3f
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/api/ServersController.java
@@ -0,0 +1,36 @@
+package nl.andrewl.aos2registryapi.api;
+
+import nl.andrewl.aos2registryapi.ServerRegistry;
+import nl.andrewl.aos2registryapi.dto.ServerInfoPayload;
+import nl.andrewl.aos2registryapi.dto.ServerInfoResponse;
+import nl.andrewl.aos2registryapi.model.ServerIdentifier;
+import org.springframework.http.ResponseEntity;
+import org.springframework.http.server.reactive.ServerHttpRequest;
+import org.springframework.web.bind.annotation.*;
+import reactor.core.publisher.Flux;
+import reactor.core.publisher.Mono;
+
+@RestController
+@RequestMapping(path = "/servers")
+public class ServersController {
+ private final ServerRegistry serverRegistry;
+
+ public ServersController(ServerRegistry serverRegistry) {
+ this.serverRegistry = serverRegistry;
+ }
+
+ @GetMapping
+ public Flux getServers() {
+ return serverRegistry.getServers();
+ }
+
+ @PostMapping
+ public Mono> updateServer(ServerHttpRequest req, @RequestBody Mono payloadMono) {
+ String host = req.getRemoteAddress().getAddress().getHostAddress();
+ return payloadMono.mapNotNull(payload -> {
+ ServerIdentifier ident = new ServerIdentifier(host, payload.port());
+ serverRegistry.acceptInfo(ident, payload);
+ return ResponseEntity.ok(null);
+ });
+ }
+}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/dto/ServerInfoPayload.java b/registry/src/main/java/nl/andrewl/aos2registryapi/dto/ServerInfoPayload.java
new file mode 100644
index 0000000..7c8e124
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/dto/ServerInfoPayload.java
@@ -0,0 +1,9 @@
+package nl.andrewl.aos2registryapi.dto;
+
+public record ServerInfoPayload (
+ int port,
+ String name,
+ String description,
+ int maxPlayers,
+ int currentPlayers
+) {}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/dto/ServerInfoResponse.java b/registry/src/main/java/nl/andrewl/aos2registryapi/dto/ServerInfoResponse.java
new file mode 100644
index 0000000..c59e961
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/dto/ServerInfoResponse.java
@@ -0,0 +1,11 @@
+package nl.andrewl.aos2registryapi.dto;
+
+public record ServerInfoResponse (
+ String host,
+ int port,
+ String name,
+ String description,
+ int maxPlayers,
+ int currentPlayers,
+ long lastUpdatedAt
+) {}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/model/ServerIdentifier.java b/registry/src/main/java/nl/andrewl/aos2registryapi/model/ServerIdentifier.java
new file mode 100644
index 0000000..ddd320b
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/model/ServerIdentifier.java
@@ -0,0 +1,3 @@
+package nl.andrewl.aos2registryapi.model;
+
+public record ServerIdentifier(String host, int port) {}
diff --git a/registry/src/main/java/nl/andrewl/aos2registryapi/model/ServerInfo.java b/registry/src/main/java/nl/andrewl/aos2registryapi/model/ServerInfo.java
new file mode 100644
index 0000000..6e9707e
--- /dev/null
+++ b/registry/src/main/java/nl/andrewl/aos2registryapi/model/ServerInfo.java
@@ -0,0 +1,59 @@
+package nl.andrewl.aos2registryapi.model;
+
+import java.time.Instant;
+
+public class ServerInfo {
+ private String name;
+ private String description;
+ private int maxPlayers;
+ private int currentPlayers;
+ private Instant lastUpdatedAt;
+
+ public ServerInfo(String name, String description, int maxPlayers, int currentPlayers) {
+ this.name = name;
+ this.description = description;
+ this.maxPlayers = maxPlayers;
+ this.currentPlayers = currentPlayers;
+ this.lastUpdatedAt = Instant.now();
+ }
+
+ public String getName() {
+ return name;
+ }
+
+ public String getDescription() {
+ return description;
+ }
+
+ public int getMaxPlayers() {
+ return maxPlayers;
+ }
+
+ public int getCurrentPlayers() {
+ return currentPlayers;
+ }
+
+ public Instant getLastUpdatedAt() {
+ return lastUpdatedAt;
+ }
+
+ public void setName(String name) {
+ this.name = name;
+ }
+
+ public void setDescription(String description) {
+ this.description = description;
+ }
+
+ public void setMaxPlayers(int maxPlayers) {
+ this.maxPlayers = maxPlayers;
+ }
+
+ public void setCurrentPlayers(int currentPlayers) {
+ this.currentPlayers = currentPlayers;
+ }
+
+ public void setLastUpdatedAt(Instant lastUpdatedAt) {
+ this.lastUpdatedAt = lastUpdatedAt;
+ }
+}
diff --git a/registry/src/main/resources/application.properties b/registry/src/main/resources/application.properties
new file mode 100644
index 0000000..1081375
--- /dev/null
+++ b/registry/src/main/resources/application.properties
@@ -0,0 +1 @@
+spring.main.web-application-type=REACTIVE